--
-- FB_top.vhd
-- Author : David Humphrey (dave.humphrey@csiro.au)
-- Description
--  Top level for the perentie filterbanks. Includes :
--   - Correlator filterbank - 4096 point FFT, 12 tap FIR filter, 4 streams simultaneously.
--   - PSS filterbank - 64 point FFT, 12 tap FIR filter, 6 streams simultaneously.
--   - PST filterbank - 256 point FFT, 12 tap FIR filter, oversampled by 4/3, 6 streams simultaneously.
--   - MACE interface, which is just to allow reading/writing of the filter taps in the filterbanks.
--     *** WARNING *** MACE slave is manually written. MACE slave module is NOT auto-generated by ARGS. 
--     Changing the yaml file will not change the actual registers.
--     This is to allow the memories to reside in the filters, rather than being pulled out and put into 
--     ARGs. 
--
----------------------------------------------------------------------------------------------------------
library IEEE, axi4_lib, ctc_lib, common_lib, filterbanks_lib, dsp_top_lib;
--use ctc_lib.ctc_pkg.all;
use dsp_top_lib.dsp_top_pkg.all;
use common_lib.common_pkg.all;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use axi4_lib.axi4_lite_pkg.ALL;
use axi4_lib.axi4_full_pkg.ALL;
--USE filterbanks_lib.filterbanks_reg_pkg.ALL;

entity FB_Top is
    generic(
        USE_CORRELATOR_FB : boolean := true;
        USE_PSS_FB : boolean := true;
        USE_PST_FB : boolean := true
    );
    port(
        -- clock, target is 400 MHz
        i_data_clk       : in std_logic;
        i_data_rst       : in std_logic;
        -- AXI slave interface, 64k word block of space with the fir filter coefficients.
        i_MACE_clk  : in std_logic;
        i_MACE_rst  : in std_logic;
        i_axi_mosi  : in  t_axi4_full_mosi;
        o_axi_miso  : out t_axi4_full_miso;
        -- Configuration (on i_data_clk)
        i_fineDelayDisable : in std_logic;
        i_RFIScale         : in std_logic_vector(4 downto 0);
        -----------------------------------------
        -- Correlator filterbank input.
        i_CorSOF         : in std_logic;                            -- start of frame.
        i_CorHeader      : in t_ctc_output_header_a(1 downto 0);    -- meta data belonging to the data coming out
        i_CorHeaderValid : in std_logic;                            -- new meta data (every output packet, aka 4096 cycles) 
        i_CorData        : in t_ctc_output_data_a(1 downto 0);      -- the actual output data
        i_CorDataValid   : in std_logic;
        -- Correlator Filterbank output
        o_CorHeader      : out t_FD_output_header;              -- meta data belonging to the data coming out of the fine Delay (FD)
        o_CorHeaderValid : out std_logic;                       -- new meta data (every output packet, aka 4096 cycles) 
        o_CorData        : out t_ctc_output_data_a(1 downto 0); -- The actual output data; 2 stations, 2 polarisations, complex 8 bit data.
        o_CorDataValid   : out std_logic;
        -----------------------------------------
        -- PSS and PST Data input, common valid signal, expects packets of 64 samples. 
        -- Requires at least 2 clocks idle time between packets.
        -- Due to oversampling, also requires on average 86 clocks between packets - specifically, no more than 3 packets in 258 clocks.
        i_PSSPSTSOF         : in std_logic; 
        i_PSSPSTHeader      : in t_ctc_output_header_a(2 downto 0);
        i_PSSPSTHeaderValid : in std_logic;
        i_PSSPSTData        : in t_ctc_output_data_a(2 downto 0);
        i_PSSPSTDataValid   : in std_logic;
        -- PSS filterbank data Output
        o_PSSHeader      : out t_ctc_output_header_a(2 downto 0);
        o_PSSHeaderValid : out std_logic;
        o_PSSData        : out t_ctc_output_data_a(2 downto 0);
        o_PSSDataValid   : out std_logic;
        -- PST filterbank data output
        o_PSTHeader      : out t_ctc_output_header_a(2 downto 0);
        o_PSTHeaderValid : out std_logic;
        o_PSTData        : out t_ctc_output_data_a(2 downto 0);
        o_PSTDataValid   : out std_logic
    );
end FB_Top;

architecture Behavioral of FB_Top is
    
    signal firtap_addr : std_logic_vector(15 downto 0);
    signal firtap_clk : std_logic;
    signal cor_we : std_logic;
    signal PSS_we : std_logic;
    signal PST_we : std_logic;
    signal corFirRd_data : std_logic_vector(17 downto 0);
    signal PSTfirRd_data : std_logic_vector(17 downto 0);
    signal PSSfirRd_data : std_logic_vector(17 downto 0);
    signal firtap_wr_data : std_logic_vector(17 downto 0);
    
    signal CorDin0, CorDin1, CorDin2, CorDin3 : t_slv_8_arr(1 downto 0);
    signal CorMetaIn, CorMetaOut : std_logic_vector(223 downto 0);
    signal CorDout0, CorDout1, CorDout2, CorDout3 : t_slv_16_arr(1 downto 0);
    signal CorValidOut, CorValidOutDel : std_logic;
    
    signal PSSPSTDin0, PSSPSTDin1, PSSPSTDin2, PSSPSTDin3, PSSPSTDin4, PSSPSTDin5 : t_slv_8_arr(1 downto 0);
    signal PSSPSTMetaIn, PSSMetaOut, PSTMetaOut : std_logic_vector(335 downto 0);
    signal PSTDout0, PSTDout1, PSTDout2, PSTDout3, PSTDout4, PSTDout5 : t_slv_16_arr(1 downto 0);
    signal PSSDout0, PSSDout1, PSSDout2, PSSDout3, PSSDout4, PSSDout5 : t_slv_16_arr(1 downto 0);
    signal PSSValidOut, PSTValidOut, PSSValidOutDel, PSTValidOutDel : std_logic;
    
    signal corFBout : t_FB_output_payload_a(1 downto 0);
    signal corFBHeader : t_ctc_output_header_a(1 downto 0);
    signal corFBHeaderValid : std_logic;
    
    signal FDcorDataValid : std_logic_vector(1 downto 0);
    signal FDcorHeaderValid : std_logic_vector(1 downto 0);
    signal FDHeader : t_ctc_output_header_a(1 downto 0);
    
    signal pssclk, pstclk : std_logic; -- for faster simulation, clock can be set to zero.
    
begin
    
    -----------------------------------------------------------------------------------
    -- Correlator Filterbank
    --
    -- Note : 
    --    type t_ctc_output_header is record
    --        timestamp         : std_logic_vector(42 downto 0);
    --        coarse_delay      : std_logic_vector(11 downto 0);
    --        virtual_channel   : std_logic_vector(8 downto 0);
    --        station_id        : std_logic_vector(8 downto 0);
    --        hpol_phase_shift  : std_logic_vector(15 downto 0);  
    --        vpol_phase_shift  : std_logic_vector(15 downto 0);  
    --    end record;
    
    CorDin0(0) <= i_CorData(0).data.vpol.re;
    CorDin0(1) <= i_CorData(0).data.vpol.im;
    CorDin1(0) <= i_CorData(0).data.hpol.re;
    CorDin1(1) <= i_CorData(0).data.hpol.im;
    CorDin2(0) <= i_CorData(1).data.vpol.re;
    CorDin2(1) <= i_CorData(1).data.vpol.im;
    CorDin3(0) <= i_CorData(1).data.hpol.re;
    CorDin3(1) <= i_CorData(1).data.hpol.im;
    CorMetaIn(111 downto 0) <= header_to_slv(i_CorHeader(0));
    CorMetaIn(223 downto 112) <= header_to_slv(i_CorHeader(1));
    
    corfbi : entity filterbanks_lib.correlatorFBTop25
    generic map (
        METABITS => 224,    --  integer := 64; -- Width in bits of the meta_i and meta_o ports.
        FRAMESTODROP => 11  --  integer := 11  -- Number of output frames to drop after a reset (to account for initialisation of the filterbank)
    )
    port map(
        -- clock, target is 380 MHz
        clk => i_data_clk,  -- in std_logic;
        rst => i_corSOF,    -- in std_logic;
        -- Data input, common valid signal, expects packets of 4096 samples. Requires at least 2 clocks idle time between packets.
        data0_i => CorDin0,        -- in t_slv_8_arr(1:0); 4 Inputs, each complex data, 8 bit real, 8 bit imaginary.
        data1_i => CorDin1,        -- in t_slv_8_arr(1:0);
        data2_i => CorDin2,        -- in t_slv_8_arr(1:0);
        data3_i => CorDin2,        -- in t_slv_8_arr(1:0);
        meta_i  => CorMetaIn,        -- in ((METABITS-1) downto 0);
        valid_i => i_CorDataValid, -- in std_logic;
        -- Data out; bursts of 3456 clocks for each channel.
        data0_o => CorDout0,    -- out t_slv_16_arr(1 downto 0);   -- 4 outputs, real and imaginary parts in (0) and (1) respectively;
        data1_o => CorDout1,    -- out t_slv_16_arr(1 downto 0);
        data2_o => CorDout2,    -- out t_slv_16_arr(1 downto 0);
        data3_o => CorDout3,    -- out t_slv_16_arr(1 downto 0);
        meta_o  => CorMetaOut,  -- out std_logic_vector((METABITS-1) downto 0);
        valid_o => CorValidOut, -- out std_logic;
        -- Writing FIR Taps
        FIRTapData_i => firtap_wr_data, --: in std_logic_vector(17 downto 0);  -- For register writes of the filtertaps.
        FIRTapData_o => corFirRd_data, -- : out std_logic_vector(17 downto 0); -- For register reads of the filtertaps. 3 cycle latency from FIRTapAddr_i
        FIRTapAddr_i => firtap_addr(15 downto 0), --: in std_logic_vector(15 downto 0);  -- 4096 * 12 filter taps = 49152 total.
        FIRTapWE_i   => cor_we, -- : in std_logic;
        FIRTapClk    => firtap_clk --: in std_logic
    );

    -- Pack the correlator filterbank output into a structure for input to the fine delay module.
    corFBout(0).vpol.re <= CorDout0(0);  -- 16 bit data into the fine delay module.
    corFBout(0).vpol.im <= CorDout0(1);
    corFBout(0).hpol.re <= CorDout1(0);
    corFBout(0).hpol.im <= CorDout1(1);
    corFBout(1).vpol.re <= CorDout2(0);  -- 16 bit data into the fine delay module.
    corFBout(1).vpol.im <= CorDout2(1);
    corFBout(1).hpol.re <= CorDout3(0);
    corFBout(1).hpol.im <= CorDout3(1);
    --o_CorDataValid <= CorValidOut;
    corFBHeader(0) <= slv_to_header(CorMetaOut(111 downto 0));
    corFBHeader(1) <= slv_to_header(CorMetaOut(223 downto 112));
    corFBHeaderValid <= CorValidOut and (not CorValidOutDel);
    
    process(i_data_clk)
    begin
        if rising_edge(i_data_clk) then
            CorValidOutDel <= CorValidOut;
        end if;
    end process;
    
    corFDGen : for i in 0 to 1 generate 
        corFineDelay : entity filterbanks_lib.fineDelay
        generic map (
            FBSELECTION => 2
        )
        port map (
            i_clk  => i_data_clk,
            -- data and header in
            i_data        => corFBout(i),
            i_dataValid   => CorValidOut,
            i_header      => corFBHeader(i),
            i_headerValid => corFBHeaderValid,
            -- Data and Header out
            o_data        => o_corData(i),
            o_dataValid   => FDcorDataValid(i),
            o_header      => FDHeader(i),
            o_headerValid => FDcorHeaderValid(i),
            -------------------------------------------
            -- control and monitoring
            -- Disable the fine delay. Instead of multiplying by the output of the sin/cos lookup, just scale by unity.
            i_disable     => i_fineDelayDisable, -- in std_logic;
            -- Scale down by 2^(i_RFIScale) before clipping for RFI.
            -- Unity for the sin/cos lookup is 0x10000, so :
            --   i_RFIScale < 16  ==> Amplify the output of the filterbanks.
            --   i_RFIScale = 16  ==> Amplitude of the filterbank output is unchanged.
            --   i_RFIScale > 16  ==> Amplitude of the filterbank output is reduced.
            i_RFIScale    => i_RFIScale, -- in std_logic_vector(4 downto 0); 
            -- For monitoring of the output level.
            -- Higher level should keep track of : 
            --   * The total number of frames processed.
            --   * The sum of each of the outputs below. (but note one is superfluous since it can be calculated from the total frames processed and the sum of all the others).
            --      - These sums should be 32 bit values, which ensures wrapping will occur at most once per hour.
            -- For the correlator:
            --   - Each frame corresponds to 3456 fine channels x 2 (H & V polarisations) * 2 (re+im).
            --   - Every fine channel must be one of the categories below, so they will sum to 3456*2*2 = 13824.
            o_overflow    => open, -- hist_overflow(i),     -- out(15:0); -- Number of fine channels which were clipped.
            o_64_127      => open, -- hist_64_127(i),  -- out(15:0); -- Number of fine channels in the range 64 to 128.
            o_32_63       => open, -- hist_32_63(i),   -- out(15:0); -- Number of fine channels in the range 32 to 64.
            o_16_31       => open, -- hist_16_31(i),   -- out(15:0); -- Number of fine channels in the range 16 to 32.
            o_0_15        => open, -- hist_0_15(i),    -- out(15:0); -- Number of fine channels in the range 0 to 15.
            o_station     => open, -- hist_station(i), -- out(8:0);
            o_virtualChannel => open, -- hist_virtualChannel(i), -- out(8:0);
            o_histogramValid => open  -- hist_valid(i) -- out std_logic -- indicates histogram data is valid.
        );
    end generate;
    
    o_corDataValid <= FDcorDataValid(0);  -- FDcorDataValid(0) and (1) will be the same.
    o_corHeaderValid <= FDcorHeaderValid(0);
    -- merge the headers from the two data streams. The streams should be for the same virtual channel, but different stations.
    o_corHeader.timestamp       <= FDHeader(0).timestamp;       -- (31:0);
    o_corHeader.virtual_channel <= FDHeader(0).virtual_channel; -- (15:0);
    o_corHeader.station_id0     <= FDHeader(0).station_id;      -- (15:0);
    o_corHeader.station_id1     <= FDHeader(1).station_id;      -- (15:0);  -- Data for two stations is packed into a single packet
    o_corHeader.fine_channel    <= (others => '0'); -- (15:0);
    o_corHeader.coarse_delay0   <= FDHeader(0).coarse_delay;
    o_corHeader.coarse_delay1   <= FDHeader(1).coarse_delay;


    -----------------------------------------------------------------------------------
    -- PST Filterbank
    PSSPSTDin0(0) <= i_PSSPSTData(0).data.vpol.re;
    PSSPSTDin0(1) <= i_PSSPSTData(0).data.vpol.im;
    PSSPSTDin1(0) <= i_PSSPSTData(0).data.hpol.re;
    PSSPSTDin1(1) <= i_PSSPSTData(0).data.hpol.im;
    PSSPSTDin2(0) <= i_PSSPSTData(1).data.vpol.re;
    PSSPSTDin2(1) <= i_PSSPSTData(1).data.vpol.im;
    PSSPSTDin3(0) <= i_PSSPSTData(1).data.hpol.re;
    PSSPSTDin3(1) <= i_PSSPSTData(1).data.hpol.im;
    PSSPSTDin4(0) <= i_PSSPSTData(2).data.vpol.re;
    PSSPSTDin4(1) <= i_PSSPSTData(2).data.vpol.im;
    PSSPSTDin5(0) <= i_PSSPSTData(2).data.hpol.re;
    PSSPSTDin5(1) <= i_PSSPSTData(2).data.hpol.im;
    
    PSSPSTMetaIn(111 downto 0) <= header_to_slv(i_PSSPSTHeader(0));
    PSSPSTMetaIn(223 downto 112) <= header_to_slv(i_PSSPSTHeader(1));
    PSSPSTMetaIn(335 downto 224) <= header_to_slv(i_PSSPSTHeader(2));
    
    fbpstgen : if (USE_PST_FB) generate
        pstclk <= i_data_clk;
    end generate;
    
    fbpstnogen : if (not USE_PST_FB) generate
        pstclk <= '0';
    end generate;

    
    pstfbi : entity filterbanks_lib.PSTFBTop
    generic map(
        METABITS => 336,    -- Width in bits of the meta_i and meta_o ports.
        FRAMESTODROP => 11  -- Number of output frames to drop after a reset (to account for initialisation of the filterbank)
    )
    port map (
        -- processing clock
        clk         => pstclk,
        rst         => i_PSSPSTSOF,
        FIRTapUse_i => '0', --in std_logic; FIR Taps are double buffered, choose which set of TAPs to use.
        -- Data input, common valid signal, expects packets of 64 samples. 
        -- Requires at least 2 clocks idle time between packets.
        -- Due to oversampling, also requires on average 86 clocks between packets - specifically, no more than 3 packets in 258 clocks. 
        data0_i => PSSPSTDin0, -- in t_slv_8_arr(1 downto 0);  -- 6 Inputs, each complex data, 8 bit real, 8 bit imaginary.
        data1_i => PSSPSTDin1, -- in t_slv_8_arr(1 downto 0);
        data2_i => PSSPSTDin2, -- in t_slv_8_arr(1 downto 0);
        data3_i => PSSPSTDin3, -- in t_slv_8_arr(1 downto 0);
        data4_i => PSSPSTDin4, -- in t_slv_8_arr(1 downto 0);
        data5_i => PSSPSTDin5, -- in t_slv_8_arr(1 downto 0);
        meta_i  => PSSPSTMetaIn, -- in std_logic_vector((METABITS-1) downto 0);  -- Sampled on the first cycle of every third packet of valid_i. 
        valid_i => i_PSSPSTDataValid, -- in std_logic;
        -- Data out; bursts of 216 clocks for each channel.
        data0_o => PSTDout0,    -- out t_slv_16_arr(1 downto 0);   -- 6 outputs, real and imaginary parts in (0) and (1) respectively;
        data1_o => PSTDout1,    -- out t_slv_16_arr(1 downto 0);
        data2_o => PSTDout2,    -- out t_slv_16_arr(1 downto 0);
        data3_o => PSTDout3,    -- out t_slv_16_arr(1 downto 0);
        data4_o => PSTDout4,    -- out t_slv_16_arr(1 downto 0);
        data5_o => PSTDout5,    -- out t_slv_16_arr(1 downto 0);
        meta_o  => PSTMetaOut,  -- out std_logic_vector((METABITS-1) downto 0);
        valid_o => PSTValidOut, -- out std_logic;
        -- Writing FIR Taps
        FIRTapData_i   => firtap_wr_data, --: in std_logic_vector(17 downto 0);  -- For register writes of the filtertaps.
        FIRTapData_o   => PSTfirRd_data, -- : out std_logic_vector(17 downto 0); -- For register reads of the filtertaps. 3 cycle latency from FIRTapAddr_i
        FIRTapAddr_i   => firtap_addr(11 downto 0), --: in std_logic_vector(11 downto 0);   -- 256 * 12 filter taps = 3072 total.
        FIRTapWE_i     => PST_we, -- : in std_logic;
        FIRTapClk      => firtap_clk, --: in std_logic;
        FIRTapSelect_i => '0' -- : in std_logic  -- FIR Taps are double buffered; This selects the buffer to access for registers. Choose which buffer to use with FIRTapUse_i
    );

    -- Just use the low 8 bits; need to replace this with the RFI module.
    o_PSTData(0).data.vpol.re <= PSTDout0(0)(7 downto 0);
    o_PSTData(0).data.vpol.im <= PSTDout0(1)(7 downto 0);
    o_PSTData(0).data.hpol.re <= PSTDout1(0)(7 downto 0);
    o_PSTData(0).data.hpol.im <= PSTDout1(1)(7 downto 0);
    o_PSTData(1).data.vpol.re <= PSTDout2(0)(7 downto 0);
    o_PSTData(1).data.vpol.im <= PSTDout2(1)(7 downto 0);
    o_PSTData(1).data.hpol.re <= PSTDout3(0)(7 downto 0);
    o_PSTData(1).data.hpol.im <= PSTDout3(1)(7 downto 0);
    o_PSTData(2).data.vpol.re <= PSTDout4(0)(7 downto 0);
    o_PSTData(2).data.vpol.im <= PSTDout4(1)(7 downto 0);
    o_PSTData(2).data.hpol.re <= PSTDout5(0)(7 downto 0);
    o_PSTData(2).data.hpol.im <= PSTDout5(1)(7 downto 0);
    o_PSTDataValid <= PSTValidOut;
    
    o_PSTHeader(0) <= slv_to_header(PSTMetaOut(111 downto 0));
    o_PSTHeader(1) <= slv_to_header(PSTMetaOut(223 downto 112));
    o_PSTHeader(2) <= slv_to_header(PSTMetaOut(335 downto 224));
    
    o_PSTHeaderValid <= PSTValidOut and (not PSTValidOutDel);
    
    process(i_data_clk)
    begin
        if rising_edge(i_data_clk) then
            PSTValidOutDel <= PSTValidOut;
        end if;
    end process;

    fbgen : if (USE_PSS_FB) generate
        pssclk <= i_data_clk;
    end generate;
    
    fbnogen : if (not USE_PSS_FB) generate
        pssclk <= '0';
    end generate;
    
    
    pssfbi : entity filterbanks_lib.PSSFBTop
    port map(
        -- processing clock
        clk         => pssclk, -- i_data_clk,
        rst         => i_PSSPSTSOF,
        FIRTapUse_i => '0', -- : in std_logic;   -- FIR Taps are double buffered, choose which set of TAPs to use.
        -- Data input, common valid signal, expects packets of 64 samples. Requires at least 2 clocks idle time between packets.
        data0_i => PSSPSTDin0, -- in t_slv_8_arr(1 downto 0);  -- 6 Inputs, each complex data, 8 bit real, 8 bit imaginary.
        data1_i => PSSPSTDin1, -- in t_slv_8_arr(1 downto 0);
        data2_i => PSSPSTDin2, -- in t_slv_8_arr(1 downto 0);
        data3_i => PSSPSTDin3, -- in t_slv_8_arr(1 downto 0);
        data4_i => PSSPSTDin4, -- in t_slv_8_arr(1 downto 0);
        data5_i => PSSPSTDin5, -- in t_slv_8_arr(1 downto 0);
        valid_i => i_PSSPSTDataValid, -- in std_logic;
        -- Data out; bursts of 54 clocks for each channel.
        data0_o => PSSDout0,    -- out t_slv_16_arr(1 downto 0);   -- 6 outputs, real and imaginary parts in (0) and (1) respectively;
        data1_o => PSSDout1,    -- out t_slv_16_arr(1 downto 0);
        data2_o => PSSDout2,    -- out t_slv_16_arr(1 downto 0);
        data3_o => PSSDout3,    -- out t_slv_16_arr(1 downto 0);
        data4_o => PSSDout4,    -- out t_slv_16_arr(1 downto 0);
        data5_o => PSSDout5,    -- out t_slv_16_arr(1 downto 0);
        valid_o => PSSValidOut,  -- out std_logic;
        -- Writing FIR Taps
        FIRTapData_i   => firtap_wr_data, --: in std_logic_vector(17 downto 0);  -- For register writes of the filtertaps.
        FIRTapData_o   => PSSfirRd_data, --: out std_logic_vector(17 downto 0); -- For register reads of the filtertaps. 3 cycle latency from FIRTapAddr_i
        FIRTapAddr_i   => firtap_addr(9 downto 0), -- : in std_logic_vector(9 downto 0);   -- 64 * 12 filter taps = 768 total.
        FIRTapWE_i     => PSS_we, -- : in std_logic;
        FIRTapClk      => firtap_clk, --  in std_logic;
        FIRTapSelect_i => '0' -- : in std_logic  -- FIR Taps are double buffered; This selects the buffer to access for registers. Choose which buffer to use with FIRTapUse_i
    );

    -- Just use the low 8 bits; need to replace this with the RFI module.
    o_PSSData(0).data.vpol.re <= PSSDout0(0)(7 downto 0);
    o_PSSData(0).data.vpol.im <= PSSDout0(1)(7 downto 0);
    o_PSSData(0).data.hpol.re <= PSSDout1(0)(7 downto 0);
    o_PSSData(0).data.hpol.im <= PSSDout1(1)(7 downto 0);
    o_PSSData(1).data.vpol.re <= PSSDout2(0)(7 downto 0);
    o_PSSData(1).data.vpol.im <= PSSDout2(1)(7 downto 0);
    o_PSSData(1).data.hpol.re <= PSSDout3(0)(7 downto 0);
    o_PSSData(1).data.hpol.im <= PSSDout3(1)(7 downto 0);
    o_PSSData(2).data.vpol.re <= PSSDout4(0)(7 downto 0);
    o_PSSData(2).data.vpol.im <= PSSDout4(1)(7 downto 0);
    o_PSSData(2).data.hpol.re <= PSSDout5(0)(7 downto 0);
    o_PSSData(2).data.hpol.im <= PSSDout5(1)(7 downto 0);
    o_PSSDataValid <= PSSValidOut;
    
    -- To be fixed...
    o_PSSHeader(0).timestamp        <= (others => '0');
    o_PSSHeader(0).coarse_delay     <= (others => '0');
    o_PSSHeader(0).virtual_channel  <= (others => '0');
    o_PSSHeader(0).station_id       <= (others => '0');
    o_PSSHeader(0).hpol_phase_shift <= (others => '0');
    o_PSSHeader(0).vpol_phase_shift <= (others => '0');
    o_PSSHeader(1).timestamp        <= (others => '0');
    o_PSSHeader(1).coarse_delay     <= (others => '0');
    o_PSSHeader(1).virtual_channel  <= (others => '0');
    o_PSSHeader(1).station_id       <= (others => '0');
    o_PSSHeader(1).hpol_phase_shift <= (others => '0');
    o_PSSHeader(1).vpol_phase_shift <= (others => '0');
    o_PSSHeader(2).timestamp        <= (others => '0');
    o_PSSHeader(2).coarse_delay     <= (others => '0');
    o_PSSHeader(2).virtual_channel  <= (others => '0');
    o_PSSHeader(2).station_id       <= (others => '0');
    o_PSSHeader(2).hpol_phase_shift <= (others => '0');
    o_PSSHeader(2).vpol_phase_shift <= (others => '0'); 
    
    o_PSSHeaderValid <= PSSValidOut and (not PSSValidOutDel);
    
    process(i_data_clk)
    begin
        if rising_edge(i_data_clk) then
            PSSValidOutDel <= PSSValidOut;
        end if;
    end process;
    
    ---------------------------------------------------------------
    -- Programming the FIR taps in the filters
    
    mmfirtapsi : entity filterbanks_lib.filterbanks_firtaps_ram
    port map (
        -- full AXI bus
        CLK_A      => i_MACE_clk, -- IN  STD_LOGIC;
        RST_A      => i_MACE_rst, -- IN  STD_LOGIC;
        MM_IN      => i_axi_mosi, -- IN  t_axi4_full_mosi;
        MM_OUT     => o_axi_miso, -- OUT t_axi4_full_miso;
        -- Interface to the memories. Should be a 3 cycle latency for reads
        -- Note - two extra cycles of latency added in this file, so axi interface is configured for 5 cycle read latency.
        -- Common memory interface signals
        mem_clk    => firtap_clk,  -- out std_logic;
        mem_rst    => open,        -- out std_logic;
        mem_addr   => firtap_addr, -- out std_logic_vector(15 downto 0);
        mem_wr_data => firtap_wr_data, --  out std_logic_vector(17 downto 0);
        -- Correlator - address 0 to 49151 (0x0 to 0xC000)
        o_cor_we     => cor_we, -- : out std_logic;
        i_cor_rd_data => corFirRd_data, -- : in std_logic_vector(17 downto 0);
        -- PST - 3072 words, address 49152 to 52223 (0xC000 to 0xCBFF)
        o_PST_we => PST_we, -- : out std_logic;
        i_PST_rd_data => PSTfirRd_data, -- : in std_logic_vector(17 downto 0);
        -- PSS - 768 words, Address 53248 to 54015 (0xD000 to 0xD2FF)
        o_PSS_we  => PSS_we, -- : out std_logic;
        i_PSS_rd_data => PSSfirRd_data -- : in std_logic_vector(17 downto 0)
    ); 
    
    
end Behavioral;